code            segment
                assume cs:code, ds:code, es:code, ss:code
                org 0100h
                ; ύXs
start:          JMP     __main
msg_ttl0        DB      0E1h,"  [ Video Freq ] ",0
msg_freq        DB      0E5h," g ",0
msg_H98         DB      0E1h,"  PC-H98V[Y͑ΏۊOł.",13,10,0
msg_hireso      DB      041h,"  nC][h͑ΏۊOł.",13,10,0
msg_undefined   DB      0E1h,"  g[h͋LĂ܂. ",0
msg_not_pressed DB      0E1h,"  [GRPH]+[1] or [2] ͉Ă܂. ",0
msg_1pressed    DB      0A1h," [GRPH]+[1]Ă̂ŋL܂.",0
msg_2pressed    DB      0A1h," [GRPH]+[2]Ă̂ŋL܂.",0
msg_noexec      DB      0C1h," ύX ",0
msg_24          DB      041h," QSkHz  ",13,10,0
msg_31          DB      081h," RPkHz  ",13,10,0
;----------------------------------------------------------------------
align 2
F_INDOS         equ     02h
F_HIRESO        equ     08h
F_H98           equ     20h
F_NO9821G       equ     80h

;COLOR_ATTRIB    equ     byte ptr [bp-3]
memsw7          equ     byte ptr [bp-3]
flagset         equ     byte ptr [bp-4]
ROW             equ     word ptr [bp-6]
COLUMN          equ     word ptr [bp-8]
SegTVRAM        equ     word ptr [bp-10]
.186
__main:         
                enter   16,0
                xor     ax,ax
                mov     flagset,al
                mov     ROW,15
                mov     COLUMN,20
                mov     es,ax
                mov     dx,0A000h
                mov     al,es:[0501h]
                test    al,8
                jz      @f
                or      flagset,F_HIRESO
                mov     dh,0E0h
        @@:     mov     SegTVRAM,dx
                mov     dx,offset msg_ttl0
                call    _puts
                mov     dx,offset msg_freq
                call    _puts
                call    EnvCheck
                jc      ExitProcess
                call    ReadMemSW6_AL
                and     al,11000000b
                or      al,al
                mov     cx,4
                jnz     @f
                mov     cx,16
        @@:     call    Click
        
                mov     ah,02h
                int     18h
                test    al,8    ; [GRPH] key pressed
                jz      GRPH_Not_pressed2        ;      GRPH_Not_pressed
                mov     ah,04h
                mov     al,00h
                int     18h

                cmp     ah,2    ; bit1=[1] pressed
                je      GRPH1_ent
                cmp     ah,4    ; bit2=[2] pressed
                je      GRPH2_ent
GRPH_Not_pressed2:
                mov     dx,offset msg_not_pressed
                call    DisplayNextLine
                mov     al,memsw7
                and     al,11000000b
                or      al,al
                jz      Undefied;       ExitProcess     ; NOT defined

                cmp     al,01000000b    ; 01------> 24kHz , 00---->undefined
                je      GRPH1
                cmp     al,10000000b    ; 10------> 31kHz , 11---->other
                je      GRPH2
                jmp     ExitProcess     ; NOT defined

Undefied:
                mov     dx,offset msg_noexec
                call    _puts
                mov     dx,offset msg_undefined
                call    DisplayNextLine
                jmp     GRPH_Not_pressed     ; NOT defined
GRPH1_ent:
                mov     dx,offset msg_1pressed
                call    DisplayNextLine
GRPH1:
                mov     dx,offset msg_24 
                call    _puts
                mov     dx,09A8h
                in      al,dx
                and     al,0FCh
                out     dx,al
                mov     al,01000000b
                jmp     WriteMEMSW
GRPH2_ent:
                mov     dx,offset msg_2pressed
                call    DisplayNextLine
GRPH2:
                mov     dx,offset msg_31
                call    _puts
                mov     dx,09A8h
                in      al,dx
                or      al,01h
                out     dx,al
                mov     al,10000000b
WriteMEMSW:     call    WriteMemSW6_AL
GRPH_Not_pressed:
                call    Graphkey_check
ExitProcess:    
                leave
                RET
;--------------------------------------------------------
DisplayNextLine PROC   near
                push    ROW
                push    COLUMN
                inc     ROW
                mov     COLUMN,20
                call    _puts
                pop     COLUMN
                pop     ROW
                ret
DisplayNextLine ENDP
;--------------------------------------------------------
EnvCheck        PROC   near
                test    flagset,F_HIRESO
                jz      @f
                mov     dx,offset msg_hireso
                call    DisplayNextLine
                stc
                ret
        @@:     xor     ax,ax
                push    ds
                mov     ds,ax
                mov     al,ds:[0458h]
                mov     ah,ds:[054Ch]
                mov     dx,ds:[0486h]
                pop     ds
                and     dx,0400h
                cmp     dx,0400h        ; CPU >=486
                jae     @f
                stc
                ret
        @@: ; H98
                test    al,80h
                jz      @f
                mov     dx,offset msg_H98
                call    _puts
                stc
                ret
        @@: ; 9821 graphics
                test    ah,40h
                jnz     Exist21G
                clc
                ret
Exist21G:       or      flagset,F_NO9821G
                clc
                ret
EnvCheck        ENDP
;--------------------------------------------------------
if 0
ChangeGraphic16 PROC   near
                mov     al,07h  ; unlock
                out     6Ah,al
                mov     al,68h
                out     6Ah,al
                mov     al,20h  ;0(20h)= WOtBbNX[h
                out     6Ah,al
                mov     al,68h  ;0(68h)= 400C\
                out     6Ah,al
                mov     al,06h  ; lock
                out     6Ah,al
                mov     al,01h  ;1(01h)= 16F
                out     6Ah,al
                ret
ChangeGraphic16 ENDP
endif
;--------------------------------------------------------
EnableText      PROC   near
                mov     ah,0Ch
                int 18h
                mov     ah,11h  ; cursor enabled
                int 18h
                mov     al,0Dh
                out     0A2h,al
                ret
EnableText      ENDP
;----------------------------------------------------------------------
ShortBeep       PROC   near
                push    ax
                push    dx
                push    cx
                mov     ax,BeepTone
                mov     dx,03FDBh        ; 3FDB
                out     dx,al
                xchg    al,ah
                out     dx,al
                mov     al,6    ; beep
                out     37h,al
ShortBeep00:
                mov     cx,88h; 0FEDCh ; 
        @@:
                out     5Fh,al
                out     5Fh,al
        loop    @b
                mov     al,7    ; beep off
                out     37h,al
                mov     cx,9999h       ; 
        @@:
                out     5Fh,al
                out     5Fh,al
        loop    @b
                mov     ax,1229
                mov     dx,03FDBh        ; 3FDB
                out     dx,al
                xchg    al,ah
                out     dx,al
                pop     cx
                pop     dx
                pop     ax
                ret
BeepTone        DW      1229h
ShortBeep       ENDP

;---------------------------------------------------------------------------
Click           PROC   near
        @@:     call    ShortBeep
               loop     @b
                ret
Click           ENDP

;-------------------------------------------------------
include putstrj.s    ; _puts
;-------------------------------------------------------
WriteMemSW6_AL  PROC   near
                mov     bx,(03FF6h+4)
                mov     dl,al
                and     dl,11000000b
                mov     al,memsw7
                and     al,00111111b
                or      dl,al
                mov     al,0Dh
                out     68h,al
                out     5Fh,al
                mov     es:[bx],dl
                out     5Fh,al
                mov     al,0Ch
                out     68h,al
                mov     al,dl
                ret
WriteMemSW6_AL  ENDP

ReadMemSW6_AL   PROC   near
                mov     es,SegTVRAM
                mov     bx,(03FF6h+4)
                mov     ah,0
                mov     al,es:[bx]
                mov     memsw7,al
                ret
ReadMemSW6_AL   ENDP
;------------------------------------------------------------------
;         Graphkey_check  VtgL[`FbN҂ I
;------------------------------------------------------------------
Graphkey_check  PROC    near
                mov     cx,0EEEEh
WaitEnt:        out     5fh,al
                out     5fh,al
                out     5fh,al
                out     5fh,al
               loop     WaitEnt
        @@:     mov     ah,02h
                int 18h
                test    al,8    ; (bit 3) 8= bit mask of keyboard shift[GRPH] sens
                jnz     @b
                ret
Graphkey_check  ENDP
;---------------------------------------------------------------------------
code    ends
        end start

